/****************************************************************************
Copyright (c) 2008-2010 Ricardo Quesada
Copyright (c) 2010-2012 cocos2d-x.org
Copyright (c) 2011      Zynga Inc.
Copyright (c) 2013-2014 Chukong Technologies Inc.
 
http://www.cocos2d-x.org

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 ****************************************************************************/
package org.cocos2dx.javascript;

import org.cocos2dx.lib.Cocos2dxGLSurfaceView;
import org.cocos2dx.plugin.PluginWrapper;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;

import com.masterdangermoral.wander.R;
import com.redsdk.all.RedSDK;

public class AppActivity extends BaseGameActivity {
	public static AppActivity mContext;
	public boolean isSignInForHighScore = false;
	public static int highscore = 0;

	//支付与统计.
	@Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
    	if(!RedSDK.onActivityResult(requestCode,resultCode,data)){
    		super.onActivityResult(requestCode, resultCode, data);
    	}
    }
	
	//统计相关.
	@Override
	protected void onResume() {
		super.onResume();
		RedSDK.onResume();
	}
	@Override
	protected void onPause() {
		super.onPause();
		RedSDK.onPause();
	}
	
	@Override
	protected void onStop() {//进入前台
		super.onStop();
		RedSDK.onStop();
	}
//	@Override
//	public void onBackPressed() {//返回键
//		super.onBackPressed();
//		RedSDK.onBackPressed();
//		Log.e("onBackPressed", "返回键");
//	}
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		app = this;
		mContext = this;
		NativeUtils.setApp(app);
		RedSDK.init(this, "yuntao", false, false); 		
	}	

	@Override
	public Cocos2dxGLSurfaceView onCreateView() {
		Cocos2dxGLSurfaceView glSurfaceView = new Cocos2dxGLSurfaceView(this);
		// TestCpp should create stencil buffer
		glSurfaceView.setEGLConfigChooser(5, 6, 5, 0, 16, 8);

		PluginWrapper.init(this);
		PluginWrapper.setGLSurfaceView(glSurfaceView);
		return glSurfaceView;
	}

	
	// todo:
	public static AppActivity app = null;
	private static native void CPPJsNotiFun(String msg, String jsonstr);
	private static native void RenderInit(Context context);
	public static void startUmengUpdate() {
		Log.v("MobClick", "startUmengUpdate");
	}
	public static void StartRenderInit() {
		AppActivity.RenderInit(app);
	}
	
	//gamecenter相关.
    @Override
	public void onSignInFailed() {
		
	}

	@Override
	public void onSignInSucceeded() {
		if(isSignInForHighScore){
			isSignInForHighScore = false;
			updateTopScoreLeaderboard(highscore);
		}
	}
	
	public void onHighScoreClick(){
		if (isSignedIn()){
			updateTopScoreLeaderboard(highscore);
		}else{
			gameServicesSignIn();
			isSignInForHighScore = true;
		}
	}
	
	public static void gameServicesSignIn() {
        mContext.runOnUiThread(new Runnable() {
            public void run() {
                mContext.beginUserInitiatedSignIn();
            }
        });

    }

    public static void updateTopScoreLeaderboard(int score) {
    	
    		mContext.getGamesClient().submitScore(mContext.getResources().getString(R.string.leaderboard_high_score),
    	                score);
    		 showLeaderboards();
    }

    public static void updateAchievement(String id, int percentage) {

        mContext.getGamesClient().incrementAchievement(id,percentage);
    }

    public static void showLeaderboards() {
        mContext.runOnUiThread(new Runnable() {
            public void run() {
                mContext.startActivityForResult(mContext.getGamesClient().getLeaderboardIntent(mContext.getResources().getString(R.string.leaderboard_high_score)), 5000);
            }
        });
    }

    public static void showAchievements() {
        mContext.runOnUiThread(new Runnable() {
            public void run() {
                mContext.startActivityForResult(mContext.getGamesClient().getAchievementsIntent(), 5001);
            }
        });
    }
    
    public static void showHighScore(int score){
    	Log.v("tao", ""+score);
    	highscore = score;
    	mContext.onHighScoreClick();
    }   

}
